<?php
namespace Service;

use Doctrine\ORM\EntityManager;
use Zeedhi\DevOps\Model\Projectmanagement\Repositories;
use Zeedhi\DevOps\Model\Projectmanagement\Entities;
use Factory;
use Zeedhi\DevOps\Util\Utilities;

class TaskTypeClassification
{
    /** @var  EntityManager */
    private $entityManager;
    /** @var  \Zeedhi\DevOps\Model\Projectmanagement\Repositories\TaskStatus */
    private $taskTypeClassificationRepository;
    /** @var  Factory\TaskTypeClassification */
    private $taskTypeClassificationFactory;

    public function __construct(EntityManager $entityManager, Factory\TaskTypeClassification $taskTypeClassificationFactory)
    {
        $this->entityManager = $entityManager;
        $this->taskTypeClassificationFactory = $taskTypeClassificationFactory;
        $this->taskTypeClassificationRepository = $this->entityManager->getRepository(Utilities::PROJECT_MANAGEMENT_ENTITY_DIR . 'taskTypeClassification');
    }

    public function createTaskTypeClassification($classification, $taskType, $type)
    {
        $taskTypeClassification = $this->taskTypeClassificationRepository->findOneBy(
            array('classification' => $classification, 'taskType'=>$taskType, 'taskIssueClassif' => $type));
        if(!$taskTypeClassification){
            $taskTypeClassification  = $this->taskTypeClassificationFactory->createTaskTypeClassification( $classification, $taskType, $type);
            $this->entityManager->persist($taskTypeClassification);
        }
        return $taskTypeClassification;
    }

}