export class UploadFileFornwardSoli {
	public static indexFile = '_____file_____';

	public static dirTest2 = [
		{
			id: 'C:\\web_635\\bios',
			isExpanded: false,
			isLeaf: false,
			title: 'bios',
			children: [],
		},
		{
			id: 'C:\\web_635\\bios1',
			isExpanded: false,
			isLeaf: false,
			title: 'bios1',
			children: [],
		},
		{
			id: 'C:\\web_635\\bios2',
			isExpanded: false,
			isLeaf: false,
			title: 'bios2',
			children: [],
		},
		{
			id: 'C:\\web_635\\bios3',
			isExpanded: false,
			isLeaf: false,
			title: 'bios3',
			children: [],
		},
	];

	public static arrayToNode(dirInit: string, directories: any) {
		return directories.map((dir: String) => (
			{
				id: `${dirInit}\\${dir}`,
				isExpanded: false,
				isLeaf: false,
				title: dir,
				children: [],
			}
		));
	}

	public static arrayToGridData(dirInit: string, files: any) {
		return files.map((file: String) => (
			{
				id: `${dirInit}\\${file}`,
				title: file,
			}
		));
	}

	public static setNodeTree(dirInit: string, directories: any) {
		let nodes = this.getNodes(directories, '\\');
		if (nodes[0] && nodes[0].id === dirInit) {
			nodes = nodes[0].children;
		}
		nodes.sort((obja: any, objb: any) => {
			const a = obja.isLeaf;
			const b = objb.isLeaf;
			let aux: number = 0;
			if (a === b) {
				aux = 0;
			} else if (a) {
				aux = 1;
			} else if (b) {
				aux = -1;
			}
			return aux;
		});
		return nodes;
	}

	public static montDir(fileNameInt: string, node: any, indexs: number[]) {
		let nodeIndex = node;
		let fileName = fileNameInt;
		indexs?.forEach((value, index) => {
			fileName = `${fileName}\\${nodeIndex[index].title}`;
			nodeIndex = nodeIndex.children;
		});
		return fileName;
	}

	public static pushInExistsNode(nodes: any, node: any, dir: any): any {
		return nodes.some((nodeAux: any) => {
			if (!nodeAux.isLeaf && nodeAux.id === dir) {
				nodeAux.children.push(node);
				return true;
			}
			if (nodeAux.children.length > 0) {
				return this.pushInExistsNode(nodeAux.children, node, dir);
			}
			return false;
		});
	}

	public static getNodes(directories: any, separator: string) {
		const nodes = <any>[];

		Object.keys(directories).forEach((dir) => {
			const splitedDir = dir.split(separator);
			const nodeTitle = splitedDir.pop();

			const node = <any>{
				title: nodeTitle,
				isLeaf: false,
				isExpanded: false,
				id: dir,
				children: [],
			};

			directories[dir].files.forEach((file: any) => {
				node.children.push({
					title: file,
					isLeaf: true,
					id: dir + separator + file,
					children: [],
				});
			});

			const nodeToPush = this.pushInExistsNode(nodes, node, splitedDir.join(separator));
			if (!nodeToPush) {
				nodes.push(node);
			}
		});

		return nodes;
	}
}
